diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lte/test/test-lte-x2-handover-measures.cc ns-3.42/src/lte/test/test-lte-x2-handover-measures.cc
--- ns-3.41/src/lte/test/test-lte-x2-handover-measures.cc	2024-02-09 14:44:08.337793000 -0800
+++ ns-3.42/src/lte/test/test-lte-x2-handover-measures.cc	2024-05-29 15:29:47.128073700 -0700
@@ -749,7 +749,7 @@
 };
 
 LteX2HandoverMeasuresTestSuite::LteX2HandoverMeasuresTestSuite()
-    : TestSuite("lte-x2-handover-measures", SYSTEM)
+    : TestSuite("lte-x2-handover-measures", Type::SYSTEM)
 {
     Time checkInterval = Seconds(1);
 
@@ -789,7 +789,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(2,
                                                       1,
                                                       1,
@@ -800,7 +800,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new LteX2HandoverMeasuresTestCase(2,
                                                       1,
                                                       2,
@@ -811,7 +811,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(3,
                                                       1,
                                                       0,
@@ -822,7 +822,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(3,
                                                       1,
                                                       1,
@@ -833,7 +833,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(3,
                                                       1,
                                                       2,
@@ -844,7 +844,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::EXTENSIVE);
+                    TestCase::Duration::EXTENSIVE);
         AddTestCase(new LteX2HandoverMeasuresTestCase(4,
                                                       1,
                                                       0,
@@ -855,7 +855,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::EXTENSIVE);
+                    TestCase::Duration::EXTENSIVE);
         AddTestCase(new LteX2HandoverMeasuresTestCase(4,
                                                       1,
                                                       1,
@@ -866,7 +866,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(4,
                                                       1,
                                                       2,
@@ -877,7 +877,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
     }
 
     sched = "ns3::RrFfMacScheduler";
@@ -894,7 +894,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::EXTENSIVE);
+                    TestCase::Duration::EXTENSIVE);
         AddTestCase(new LteX2HandoverMeasuresTestCase(3,
                                                       1,
                                                       0,
@@ -905,7 +905,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(4,
                                                       1,
                                                       0,
@@ -916,7 +916,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
     }
 
     ho = "ns3::A3RsrpHandoverAlgorithm";
@@ -934,7 +934,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::EXTENSIVE);
+                    TestCase::Duration::EXTENSIVE);
         AddTestCase(new LteX2HandoverMeasuresTestCase(3,
                                                       1,
                                                       0,
@@ -945,7 +945,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(4,
                                                       1,
                                                       0,
@@ -956,7 +956,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
     }
 
     sched = "ns3::RrFfMacScheduler";
@@ -973,7 +973,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new LteX2HandoverMeasuresTestCase(3,
                                                       1,
                                                       0,
@@ -984,7 +984,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::TAKES_FOREVER);
+                    TestCase::Duration::TAKES_FOREVER);
         AddTestCase(new LteX2HandoverMeasuresTestCase(4,
                                                       1,
                                                       0,
@@ -995,7 +995,7 @@
                                                       ho,
                                                       true,
                                                       useIdealRrc),
-                    TestCase::EXTENSIVE);
+                    TestCase::Duration::EXTENSIVE);
     }
 
 } // end of LteX2HandoverMeasuresTestSuite ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/doc/Makefile ns-3.42/src/mesh/doc/Makefile
--- ns-3.41/src/mesh/doc/Makefile	2024-02-09 14:44:08.341793300 -0800
+++ ns-3.42/src/mesh/doc/Makefile	2024-05-29 15:29:47.128073700 -0700
@@ -41,7 +41,7 @@
 
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/helper/mesh-helper.cc ns-3.42/src/mesh/helper/mesh-helper.cc
--- ns-3.41/src/mesh/helper/mesh-helper.cc	2024-02-09 14:44:08.341793300 -0800
+++ ns-3.42/src/mesh/helper/mesh-helper.cc	2024-05-29 15:29:47.128073700 -0700
@@ -27,6 +27,7 @@
 #include "ns3/minstrel-wifi-manager.h"
 #include "ns3/pointer.h"
 #include "ns3/simulator.h"
+#include "ns3/string.h"
 #include "ns3/wifi-default-ack-manager.h"
 #include "ns3/wifi-default-protection-manager.h"
 #include "ns3/wifi-helper.h"
@@ -120,6 +121,13 @@
     // this is a const method, but we need to force the correct QoS setting
     ObjectFactory macObjectFactory = m_mac;
     macObjectFactory.Set("QosSupported", BooleanValue(true)); // a mesh station is a QoS station
+    // create (Qos)Txop objects
+    for (const std::string ac : {"BE", "BK", "VI", "VO"})
+    {
+        auto qosTxop =
+            CreateObjectWithAttributes<QosTxop>("AcIndex", StringValue(std::string("AC_") + ac));
+        macObjectFactory.Set(ac + "_Txop", PointerValue(qosTxop));
+    }
     std::vector<Ptr<WifiPhy>> phys = phyHelper.Create(node, device);
     NS_ABORT_IF(phys.size() != 1);
     node->AddDevice(device);
@@ -135,18 +143,19 @@
     mac->SetAddress(Mac48Address::Allocate());
     device->SetMac(mac);
     mac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
-    mac->ConfigureStandard(m_standard);
-    Ptr<FrameExchangeManager> fem = mac->GetFrameExchangeManager();
-    if (fem)
-    {
-        Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
-        protectionManager->SetWifiMac(mac);
-        fem->SetProtectionManager(protectionManager);
-
-        Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager>();
-        ackManager->SetWifiMac(mac);
-        fem->SetAckManager(ackManager);
-    }
+    mac->SetChannelAccessManagers({CreateObject<ChannelAccessManager>()});
+    ObjectFactory femFactory;
+    femFactory.SetTypeId(GetFrameExchangeManagerTypeIdName(m_standard, true));
+    auto fem = femFactory.Create<FrameExchangeManager>();
+    mac->SetFrameExchangeManagers({fem});
+    fem->SetAddress(mac->GetAddress());
+    Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
+    protectionManager->SetWifiMac(mac);
+    fem->SetProtectionManager(protectionManager);
+
+    Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager>();
+    ackManager->SetWifiMac(mac);
+    fem->SetAckManager(ackManager);
     mac->SwitchFrequencyChannel(channelId);
 
     return device;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/model/dot11s/hwmp-protocol-mac.cc ns-3.42/src/mesh/model/dot11s/hwmp-protocol-mac.cc
--- ns-3.41/src/mesh/model/dot11s/hwmp-protocol-mac.cc	2024-02-09 14:44:08.341793300 -0800
+++ ns-3.42/src/mesh/model/dot11s/hwmp-protocol-mac.cc	2024-05-29 15:29:47.128073700 -0700
@@ -321,7 +321,7 @@
 HwmpProtocolMac::SendMyPreq()
 {
     NS_LOG_FUNCTION(this);
-    if (m_preqTimer.IsRunning())
+    if (m_preqTimer.IsPending())
     {
         return;
     }
@@ -330,7 +330,7 @@
         return;
     }
     // reschedule sending PREQ
-    NS_ASSERT(!m_preqTimer.IsRunning());
+    NS_ASSERT(!m_preqTimer.IsPending());
     m_preqTimer =
         Simulator::Schedule(m_protocol->GetPreqMinInterval(), &HwmpProtocolMac::SendMyPreq, this);
     SendPreqVector(m_myPreq);
@@ -466,7 +466,7 @@
 HwmpProtocolMac::SendMyPerr()
 {
     NS_LOG_FUNCTION(this);
-    if (m_perrTimer.IsRunning())
+    if (m_perrTimer.IsPending())
     {
         return;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/model/dot11s/ie-dot11s-id.h ns-3.42/src/mesh/model/dot11s/ie-dot11s-id.h
--- ns-3.41/src/mesh/model/dot11s/ie-dot11s-id.h	2024-02-09 14:44:08.341793300 -0800
+++ ns-3.42/src/mesh/model/dot11s/ie-dot11s-id.h	2024-05-29 15:29:47.128073700 -0700
@@ -32,7 +32,6 @@
 
 /**
  * \brief a IEEE 802.11 Mesh ID element (Section 8.4.2.101 of IEEE 802.11-2012)
- * \see attribute_IeMeshId
  */
 class IeMeshId : public WifiInformationElement
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/model/mesh-point-device.cc ns-3.42/src/mesh/model/mesh-point-device.cc
--- ns-3.41/src/mesh/model/mesh-point-device.cc	2024-02-09 14:44:08.357793300 -0800
+++ ns-3.42/src/mesh/model/mesh-point-device.cc	2024-05-29 15:29:47.132073600 -0700
@@ -273,7 +273,7 @@
 MeshPointDevice::GetBroadcast() const
 {
     NS_LOG_FUNCTION(this);
-    return Mac48Address("ff:ff:ff:ff:ff:ff");
+    return Mac48Address::GetBroadcast();
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/model/mesh-wifi-interface-mac.cc ns-3.42/src/mesh/model/mesh-wifi-interface-mac.cc
--- ns-3.41/src/mesh/model/mesh-wifi-interface-mac.cc	2024-02-09 14:44:08.357793300 -0800
+++ ns-3.42/src/mesh/model/mesh-wifi-interface-mac.cc	2024-05-29 15:29:47.132073600 -0700
@@ -32,6 +32,7 @@
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
 #include "ns3/socket.h"
+#include "ns3/string.h"
 #include "ns3/trace-source-accessor.h"
 #include "ns3/wifi-mac-queue-scheduler.h"
 #include "ns3/wifi-mac-queue.h"
@@ -75,7 +76,6 @@
 }
 
 MeshWifiInterfaceMac::MeshWifiInterfaceMac()
-    : m_standard(WIFI_STANDARD_80211a)
 {
     NS_LOG_FUNCTION(this);
 
@@ -149,7 +149,7 @@
     {
         Time randomStart = Seconds(m_coefficient->GetValue());
         // Now start sending beacons after some random delay (to avoid collisions)
-        NS_ASSERT(!m_beaconSendEvent.IsRunning());
+        NS_ASSERT(!m_beaconSendEvent.IsPending());
         m_beaconSendEvent =
             Simulator::Schedule(randomStart, &MeshWifiInterfaceMac::SendBeacon, this);
         m_tbtt = Simulator::Now() + randomStart;
@@ -165,7 +165,7 @@
 MeshWifiInterfaceMac::AssignStreams(int64_t stream)
 {
     NS_LOG_FUNCTION(this << stream);
-    int64_t currentStream = stream;
+    int64_t currentStream = stream + WifiMac::AssignStreams(stream);
     m_coefficient->SetStream(currentStream++);
     for (auto i = m_plugins.begin(); i < m_plugins.end(); i++)
     {
@@ -387,7 +387,7 @@
 bool
 MeshWifiInterfaceMac::GetBeaconGeneration() const
 {
-    return m_beaconSendEvent.IsRunning();
+    return m_beaconSendEvent.IsPending();
 }
 
 Time
@@ -423,7 +423,7 @@
     NS_LOG_FUNCTION(this);
     NS_LOG_DEBUG(GetAddress() << " is sending beacon");
 
-    NS_ASSERT(!m_beaconSendEvent.IsRunning());
+    NS_ASSERT(!m_beaconSendEvent.IsPending());
 
     // Form & send beacon
     MeshWifiBeacon beacon(GetSsid(), GetSupportedRates(), m_beaconInterval.GetMicroSeconds());
@@ -597,11 +597,9 @@
 }
 
 void
-MeshWifiInterfaceMac::ConfigureStandard(WifiStandard standard)
+MeshWifiInterfaceMac::DoCompleteConfig()
 {
     NS_ABORT_IF(!GetQosSupported());
-    WifiMac::ConfigureStandard(standard);
-    m_standard = standard;
 }
 
 void
@@ -611,7 +609,7 @@
     // We use the single DCF provided by WifiMac for the purpose of
     // Beacon transmission. For this we need to reconfigure the channel
     // access parameters slightly, and do so here.
-    m_txop = CreateObject<Txop>();
+    m_txop = CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"));
     m_txop->SetWifiMac(this);
     GetLink(0).channelAccessManager->Add(m_txop);
     m_txop->SetTxMiddle(m_txMiddle);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/model/mesh-wifi-interface-mac.h ns-3.42/src/mesh/model/mesh-wifi-interface-mac.h
--- ns-3.41/src/mesh/model/mesh-wifi-interface-mac.h	2024-02-09 14:44:08.357793300 -0800
+++ ns-3.42/src/mesh/model/mesh-wifi-interface-mac.h	2024-05-29 15:29:47.132073600 -0700
@@ -205,12 +205,6 @@
      */
     void SetBeaconGeneration(bool enable);
     /**
-     * Finish configuration based on the WifiStandard being provided
-     *
-     * \param standard the WifiStandard being configured
-     */
-    void ConfigureStandard(WifiStandard standard) override;
-    /**
      * \param cwMin the minimum contention window size
      * \param cwMax the maximum contention window size
      *
@@ -227,9 +221,11 @@
      * \param stream first stream index to use
      * \return the number of stream indices assigned by this model
      */
-    int64_t AssignStreams(int64_t stream);
+    int64_t AssignStreams(int64_t stream) override;
 
   private:
+    void DoCompleteConfig() override;
+
     /**
      * Frame receive handler
      *
@@ -313,9 +309,6 @@
 
     Statistics m_stats; ///< statistics
 
-    /// Current standard: needed to configure metric
-    WifiStandard m_standard;
-
     /// Add randomness to beacon generation
     Ptr<UniformRandomVariable> m_coefficient;
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/test/dot11s/dot11s-test-suite.cc ns-3.42/src/mesh/test/dot11s/dot11s-test-suite.cc
--- ns-3.41/src/mesh/test/dot11s/dot11s-test-suite.cc	2024-02-09 14:44:08.357793300 -0800
+++ ns-3.42/src/mesh/test/dot11s/dot11s-test-suite.cc	2024-05-29 15:29:47.132073600 -0700
@@ -285,11 +285,11 @@
 };
 
 Dot11sTestSuite::Dot11sTestSuite()
-    : TestSuite("devices-mesh-dot11s", UNIT)
+    : TestSuite("devices-mesh-dot11s", Type::UNIT)
 {
-    AddTestCase(new MeshHeaderTest, TestCase::QUICK);
-    AddTestCase(new HwmpRtableTest, TestCase::QUICK);
-    AddTestCase(new PeerLinkFrameStartTest, TestCase::QUICK);
+    AddTestCase(new MeshHeaderTest, TestCase::Duration::QUICK);
+    AddTestCase(new HwmpRtableTest, TestCase::Duration::QUICK);
+    AddTestCase(new PeerLinkFrameStartTest, TestCase::Duration::QUICK);
 }
 
 static Dot11sTestSuite g_dot11sTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/test/dot11s/regression.cc ns-3.42/src/mesh/test/dot11s/regression.cc
--- ns-3.41/src/mesh/test/dot11s/regression.cc	2024-02-09 14:44:08.361793300 -0800
+++ ns-3.42/src/mesh/test/dot11s/regression.cc	2024-05-29 15:29:47.132073600 -0700
@@ -36,15 +36,15 @@
 {
   public:
     Dot11sRegressionSuite()
-        : TestSuite("devices-mesh-dot11s-regression", SYSTEM)
+        : TestSuite("devices-mesh-dot11s-regression", Type::SYSTEM)
     {
         // We do not use NS_TEST_SOURCEDIR variable here since mesh/test has
         // subdirectories
         SetDataDir(std::string("src/mesh/test/dot11s"));
-        AddTestCase(new PeerManagementProtocolRegressionTest, TestCase::QUICK);
-        AddTestCase(new HwmpSimplestRegressionTest, TestCase::QUICK);
-        AddTestCase(new HwmpReactiveRegressionTest, TestCase::QUICK);
-        AddTestCase(new HwmpProactiveRegressionTest, TestCase::QUICK);
-        AddTestCase(new HwmpDoRfRegressionTest, TestCase::QUICK);
+        AddTestCase(new PeerManagementProtocolRegressionTest, TestCase::Duration::QUICK);
+        AddTestCase(new HwmpSimplestRegressionTest, TestCase::Duration::QUICK);
+        AddTestCase(new HwmpReactiveRegressionTest, TestCase::Duration::QUICK);
+        AddTestCase(new HwmpProactiveRegressionTest, TestCase::Duration::QUICK);
+        AddTestCase(new HwmpDoRfRegressionTest, TestCase::Duration::QUICK);
     }
 } g_dot11sRegressionSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/test/flame/flame-test-suite.cc ns-3.42/src/mesh/test/flame/flame-test-suite.cc
--- ns-3.41/src/mesh/test/flame/flame-test-suite.cc	2024-02-09 14:44:08.361793300 -0800
+++ ns-3.42/src/mesh/test/flame/flame-test-suite.cc	2024-05-29 15:29:47.136073600 -0700
@@ -151,10 +151,10 @@
 };
 
 FlameTestSuite::FlameTestSuite()
-    : TestSuite("devices-mesh-flame", UNIT)
+    : TestSuite("devices-mesh-flame", Type::UNIT)
 {
-    AddTestCase(new FlameHeaderTest, TestCase::QUICK);
-    AddTestCase(new FlameRtableTest, TestCase::QUICK);
+    AddTestCase(new FlameHeaderTest, TestCase::Duration::QUICK);
+    AddTestCase(new FlameRtableTest, TestCase::Duration::QUICK);
 }
 
 static FlameTestSuite g_flameTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/test/flame/regression.cc ns-3.42/src/mesh/test/flame/regression.cc
--- ns-3.41/src/mesh/test/flame/regression.cc	2024-02-09 14:44:08.361793300 -0800
+++ ns-3.42/src/mesh/test/flame/regression.cc	2024-05-29 15:29:47.136073600 -0700
@@ -32,11 +32,11 @@
 {
   public:
     FlameRegressionSuite()
-        : TestSuite("devices-mesh-flame-regression", SYSTEM)
+        : TestSuite("devices-mesh-flame-regression", Type::SYSTEM)
     {
         // We do not use NS_TEST_SOURCEDIR variable here since mesh/test has
         // subdirectories
         SetDataDir(std::string("src/mesh/test/flame"));
-        AddTestCase(new FlameRegressionTest, TestCase::QUICK);
+        AddTestCase(new FlameRegressionTest, TestCase::Duration::QUICK);
     }
 } g_flameRegressionSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mesh/test/mesh-information-element-vector-test-suite.cc ns-3.42/src/mesh/test/mesh-information-element-vector-test-suite.cc
--- ns-3.41/src/mesh/test/mesh-information-element-vector-test-suite.cc	2024-02-09 14:44:08.361793300 -0800
+++ ns-3.42/src/mesh/test/mesh-information-element-vector-test-suite.cc	2024-05-29 15:29:47.136073600 -0700
@@ -162,9 +162,9 @@
 };
 
 MeshTestSuite::MeshTestSuite()
-    : TestSuite("devices-mesh", UNIT)
+    : TestSuite("devices-mesh", Type::UNIT)
 {
-    AddTestCase(new MeshInformationElementVectorBist, TestCase::QUICK);
+    AddTestCase(new MeshInformationElementVectorBist, TestCase::Duration::QUICK);
 }
 
 static MeshTestSuite g_meshTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/CMakeLists.txt ns-3.42/src/mobility/CMakeLists.txt
--- ns-3.41/src/mobility/CMakeLists.txt	2024-02-09 14:44:08.361793300 -0800
+++ ns-3.42/src/mobility/CMakeLists.txt	2024-05-29 15:29:47.136073600 -0700
@@ -10,6 +10,7 @@
     model/constant-velocity-helper.cc
     model/constant-velocity-mobility-model.cc
     model/gauss-markov-mobility-model.cc
+    model/geocentric-constant-position-mobility-model.cc
     model/geographic-positions.cc
     model/hierarchical-mobility-model.cc
     model/mobility-model.cc
@@ -31,6 +32,7 @@
     model/constant-velocity-helper.h
     model/constant-velocity-mobility-model.h
     model/gauss-markov-mobility-model.h
+    model/geocentric-constant-position-mobility-model.h
     model/geographic-positions.h
     model/hierarchical-mobility-model.h
     model/mobility-model.h
@@ -42,10 +44,12 @@
     model/steady-state-random-waypoint-mobility-model.h
     model/waypoint-mobility-model.h
     model/waypoint.h
-  LIBRARIES_TO_LINK ${libnetwork}
+  LIBRARIES_TO_LINK ${libantenna}
+                    ${libnetwork}
   TEST_SOURCES
     test/box-line-intersection-test.cc
     test/geo-to-cartesian-test.cc
+    test/geocentric-topocentric-conversion-test.cc
     test/mobility-test-suite.cc
     test/mobility-trace-test-suite.cc
     test/ns2-mobility-helper-test-suite.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/examples/CMakeLists.txt ns-3.42/src/mobility/examples/CMakeLists.txt
--- ns-3.41/src/mobility/examples/CMakeLists.txt	2024-02-09 14:44:08.361793300 -0800
+++ ns-3.42/src/mobility/examples/CMakeLists.txt	2024-05-29 15:29:47.136073600 -0700
@@ -1,5 +1,6 @@
 set(base_examples
     bonnmotion-ns2-example
+    constant-mobility-example
     main-random-topology
     main-random-walk
     ns2-mobility-trace
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/examples/constant-mobility-example.cc ns-3.42/src/mobility/examples/constant-mobility-example.cc
--- ns-3.41/src/mobility/examples/constant-mobility-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/mobility/examples/constant-mobility-example.cc	2024-05-29 15:29:47.136073600 -0700
@@ -0,0 +1,105 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Tokushima, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+/*
+   This example shows a comparison between node mobility set with and without the
+   use of helpers. Furthermore it shows a simple way to update the node positions.
+   More advanced position allocations and mobility patterns can be achieve with
+   the use of other helpers.
+
+   In this example, node N1 moves to the right in 3 different instances
+   during the simulation while node N0 remains static. A trace is used to print a
+   message when movement is detected in node N1.
+
+               10 m         {Sec 2}      10m         {Sec 4}      10 m      {Sec 6}
+   N0,N1 --------------------->N1--------------------> N1 ------------------> N1
+  (0,0,0)     Move Right    (10,0,0)   Move Right   (20,0,0)   Move Right   (30,0,0)
+*/
+
+#include <ns3/mobility-module.h>
+#include <ns3/node.h>
+#include <ns3/simulator.h>
+
+using namespace ns3;
+
+void
+CourseChangeCallback(Ptr<const MobilityModel> mobility)
+{
+    std::cout << Simulator::Now().As(Time::S) << " Movement detected (Node "
+              << mobility->GetObject<Node>()->GetId() << ")!\n";
+}
+
+void
+MoveNode(Ptr<Node> node, const Vector& pos)
+{
+    Ptr<MobilityModel> mobilityModel = node->GetObject<MobilityModel>();
+    NS_ASSERT_MSG(mobilityModel, "Node doesn't have a mobility model");
+    mobilityModel->SetPosition(pos);
+
+    Vector newPos = mobilityModel->GetPosition();
+
+    std::cout << Simulator::Now().As(Time::S) << " Node " << node->GetId() << " | MoveRight, Pos ("
+              << newPos.x << "," << newPos.y << "," << newPos.z << ")\n";
+}
+
+int
+main(int argc, char* argv[])
+{
+    // Method 1: Install the mobility model using the helper
+    //           The helper creates and installs the mobility to a single node
+    //           or multiple nodes in a node container. Different helpers might
+    //           have additional options.
+
+    NodeContainer nodeContainer(1);
+
+    MobilityHelper mobility;
+    mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
+
+    Ptr<ListPositionAllocator> positionAllocator = CreateObject<ListPositionAllocator>();
+    positionAllocator->Add(Vector(0, 0, 0));
+
+    mobility.SetPositionAllocator(positionAllocator);
+    Ptr<Node> n0 = nodeContainer.Get(0);
+    mobility.Install(n0);
+
+    // Method 2: Install the mobility manually
+    //           You need to manually create both, the node object and the mobility object.
+    //           After that, you aggregate the mobility to a node.
+
+    Ptr<Node> n1 = CreateObject<Node>();
+    Ptr<ConstantPositionMobilityModel> mob1 = CreateObject<ConstantPositionMobilityModel>();
+    n1->AggregateObject(mob1);
+    mob1->SetPosition(Vector(0, 0, 0));
+
+    // Set the mobility trace hook to node n1 to keep track of its movements
+    mob1->TraceConnectWithoutContext("CourseChange", MakeBoundCallback(&CourseChangeCallback));
+
+    // Schedule movements to node n1
+    Simulator::ScheduleWithContext(n1->GetId(), Seconds(2.0), &MoveNode, n1, Vector(10, 0, 0));
+
+    Simulator::ScheduleWithContext(n1->GetId(), Seconds(4.0), &MoveNode, n1, Vector(20, 0, 0));
+
+    Simulator::ScheduleWithContext(n1->GetId(), Seconds(6.0), &MoveNode, n1, Vector(30, 0, 0));
+
+    Simulator::Stop(Seconds(10));
+    Simulator::Run();
+
+    Simulator::Destroy();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/helper/ns2-mobility-helper.cc ns-3.42/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.41/src/mobility/helper/ns2-mobility-helper.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/helper/ns2-mobility-helper.cc	2024-05-29 15:29:47.136073600 -0700
@@ -620,7 +620,8 @@
     {
         return false;
     }
-    else if (IsNumber(str))
+
+    if (IsNumber(str))
     {
         std::istringstream s(str);
         s >> ret;
@@ -681,8 +682,6 @@
         result = pr.ivals[0];
         break;
     case 7: // line like $ns_ at 4 "$node_(0) set X_ 28"
-        result = pr.ivals[3];
-        break;
     case 8: // line like $ns_ at 1 "$node_(0) setdest 2 3 4"
         result = pr.ivals[3];
         break;
@@ -701,7 +700,6 @@
     case 4: // line like $node_(0) set X_ 11
         return pr.svals[0];
     case 7: // line like $ns_ at 4 "$node_(0) set X_ 28"
-        return pr.svals[3];
     case 8: // line like $ns_ at 1 "$node_(0) setdest 2 3 4"
         return pr.svals[3];
     default:
